#include <wtypes.h>

#ifndef __LL_types_h__
#define __LL_types_h__

/*
// will need to define these and others
//  if "wtypes.h" isn't included above.

#ifndef BYTE
	typedef unsigned char BYTE;
#endif

#ifndef BOOLEAN
	typedef unsigned char BOOLEAN;
#endif

#ifndef USHORT
	typedef unsigned short USHORT;
#endif

#ifndef DOUBLE 
	typedef double DOUBLE;  
#endif

#ifndef INT
	typedef int INT;
#endif

#ifndef UINT
	typedef unsigned int UINT;
#endif


#ifndef CALLBACK
#define CALLBACK __stdcall
#endif
*/



#define LL_OS_Win95		0x1 
#define LL_OS_Win98		0x2 
#define LL_OS_WinME		0x4 
#define LL_OS_Win2k		0x8 
#define LL_OS_WinXP		0x10 
#define LL_OS_WinNT		0x20	 
#define LL_OS_UNKNOWN	0x0 


#define ARG_IGNORED


//##########################################
// following used for:
//		MyLL_USB::GetLastDevError
//		MyLL_USB::GetLastAnyError
#define ERR_NO_ERROR				0x0
#define ERR_INVALID_OS				0x1
#define ERR_DLL_NOT_FOUND			0x2
#define ERR_DLL_FUNCTION_NOT_FOUND	0x4
#define ERR_NO_DEVICES_INITIALIZED	0x8
#define ERR_MEM_ALLOC_ERROR			0x10
#define ERR_INVALID_DEV_ID			0x20
#define ERR_DEV_NOT_FOUND			0x40
#define ERR_FAILED_INIT				0x80
#define ERR_DEV_NOT_INITIALIZED		0x100
#define ERR_FAILED_IO				0x200
#define ERR_FAILED_SCAN_STARTUP		0x400
#define ERR_DEV_NOT_SCANNING		0x800
#define ERR_DEV_BUSY_SCANNING		0x1000
#define ERR_WRONG_DEV_TYPE			0x2000
#define ERR_UNKNOWN_ERROR			0x10000000
//##########################################


//##########################################
// following used for MyLL_USB::GetDevStatus
#define DEV_NOT_FOUND				0x0
#define DEV_FOUND					0x1
#define DEV_DISCONNECTED			0x2
#define DEV_ENUMERATED				0x4
#define DEV_READY					0x8
#define DEV_OWNED_BY_ANOTHER		0x10
#define DEV_UNKNOWN_ERR				0x0x10000000
//used for SP_GetDevStat

#define PWR_NO_RESET_REQUIRED		0x1
#define PWR_NO_DEVICE				0x2
#define PWR_RESET_PIPE_FAILED		0x4
#define PWR_RESET_PIPE_SUCCESS		0x8
#define PWR_RESET_DEV_FAILED		0x10
#define PWR_RESET_DEV_SUCCESS		0x20
#define PWR_NO_POWER				0x40
#define PWR_YES_POWER				0x80
//used for SP_CheckPower				
//##########################################

#endif
