#include <windows.h>
#include <time.h>
#include <stdio.h>
#include <conio.h>
#include "USB_clss.h"
#include "LL_USB_c.h"

//Last modified: 10-14-02

MyLL_USB MyLL_USB;

LLABS llabs;

main()
{
	printf(MID"Initializing - please wait. . . . . .\r\n");
	if(!GetIniFileContent())
	{ printf(MID"failed to find  \"My_USB.INI\"  - locate file and try again.\r\n"); return 0; }

	if(!MyLL_USB.Init(usDevID, bDevChan, &dblDevRate)) { printf("FAILED TO INITIALIZE .. exiting\r\n"); return 0; }

	while(fDoLoop)
	{
		CLS printf(MID 
			"Enter a keystroke:\n\n"
			"P)olled data mode\t- get random voltages\n"
			"S)ingle chan scan mode\t- scan at preset interval for single channel\n"
			"M)ulti-chan scan mode\t- scan at preset interval for multiple channels\n"
			"\nany other key to exit"); 
		while(!kbhit()); int iKey = getch() | 0x20;

		switch((BYTE)iKey)
		{
			case 'p': GetVoltageByPolling(); break;
			case 's': DoScanSingleChan(); break;
			case 'm': DoScanMultiChanCal(); break;
			default: fDoLoop = FALSE; break;
		}
	}
	CLS printf(MID"closing application - please wait. . . . . .\r\n");
	return 0;
}


//----------------------------------------------\
// #### get voltages in a polled mode state >>>>>>
//----------------------------------------------/
BOOLEAN GetVoltageByPolling()
{
	clkWaitPeriod = clock() + 500;
	while(!kbhit())
	{
		if(clock() > clkWaitPeriod)
		{
			if(!MyLL_USB.GetOneVoltage(usDevID, &dblVoltage)) { printf("FAILED TO GET VOLTAGE .. exiting\r\n"); return 0; } 
			system("cls"); printf(MID"POLLED DATA MODE\n\nany key to exit\nvoltage:");
			printf(" % 2.6lf", dblVoltage); 
			clkWaitPeriod = clock() + 500;
		}
	}
	getch();
	system("cls"); printf(MID"exiting polled mode - please wait...");
	return TRUE;
}


//----------------------------------------------\
// #### do a single-channel scan  >>>>>>>>>>>>>>>>
//----------------------------------------------/
BOOLEAN DoScanSingleChan()
{
	PSCAN_INFO_USB_PNTS_SINGLE pScanInfo = new SCAN_INFO_USB_PNTS_SINGLE[1];
	pScanInfo->usNumPntsToRead = BUFF_SIZE; pScanInfo->usDevID = usDevID; USHORT usIndex = 0;

	system("cls"); printf(MID"starting scan - please wait. . . . .");

	bDevScanType = CMND_SINGLE_CHAN_SCAN;
	if(!MyLL_USB.StartScan(usDevID))
	{
		system("cls"); printf(MID"failed to start scan. (any key to continue:");
		while(!kbhit());
		getch();
		return FALSE;
	}
	system("cls"); printf(MID"getting scan data. . . .");
	DOUBLE dblCurAvgVoltage;
	uiPntCnt = 0;
	while(!kbhit())
	{
		if(MyLL_USB.GetScanVoltage(pScanInfo, adblScanVoltages))
		{
			uiPntCnt = uiPntCnt + BUFF_SIZE;
			dblCurAvgVoltage = 0;
			for(usIndex = 0; usIndex < BUFF_SIZE; usIndex++)
				dblCurAvgVoltage = dblCurAvgVoltage + adblScanVoltages[usIndex];
			dblCurAvgVoltage = dblCurAvgVoltage / (double)BUFF_SIZE;

			system("cls"); printf(MID"SINGLE-CHAN SCAN MODE\nDevice: %u   Chan: %d\n\nany key to exit\n\nscan#\t\t voltage\n", usDevID, bDevChan);
			printf("% 6u:\t\t% 2.5lf", uiPntCnt, dblCurAvgVoltage); 
		}
	}
	getch();
	system("cls"); printf(MID"exiting scan mode - please wait...");
	MyLL_USB.EndScan(usDevID);
	return TRUE;
}


//----------------------------------------------\
// #### do a multi-chan-calibration scan  >>>>>>>>
//----------------------------------------------/
BOOLEAN DoScanMultiChanCal()
{
	system("cls"); printf(MID"starting scan - please wait. . . . .");

	bDevScanType = CMND_MULTI_CHAN_CAL_SCAN;
	BYTE bActualScanChans = 8;
	if(usDevID < 4990) bActualScanChans = 4;
	if(!MyLL_USB.StartScan(usDevID, bDevScanType, bActualScanChans))
	{
		system("cls"); printf(MID"failed to start scan. (any key to continue:");
		while(!kbhit());
		getch();
		return FALSE;
	}

	system("cls"); printf(MID"getting scan data. . . .");
	DOUBLE dblCurAvgVoltage, dblCalVolts;
	USHORT usNumPntsToRead = bActualScanChans * 20; 
	USHORT usIndexChan, usIndexScan, usNumPntsRead;
	UINT* uiDataBuff = new UINT[bActualScanChans * 20];
	UINT uiStatusFlags, uiPntsInBuff, uiRawCount;
	BYTE bLastDigin;
	while(!kbhit())
	{
		usNumPntsToRead = bActualScanChans * 20; usNumPntsRead = 0;

		MyLL_USB.GetScanData(usDevID, usNumPntsToRead, &usNumPntsRead, uiDataBuff, &uiStatusFlags, &uiPntsInBuff, &bLastDigin);
		if(usNumPntsRead < usNumPntsToRead)
		{ continue; }

		system("cls"); 
		if(usDevID < 4990)
			printf("\n\n\n""MULTI-CHAN-CAL-SCAN MODE\nDevice: %u   Chan: 0,1,6,7\n\n\nany key to exit\n\nAveraging: %u\nSCAN#: %u\n\nchan voltage:\n", usDevID, usNumPntsToRead / bActualScanChans, uiPntCnt);
		else
			printf("\n\n\n""MULTI-CHAN-CAL-SCAN MODE\nDevice: %u   Chan: 0-7\n\n\nany key to exit\n\nAveraging: %u\nSCAN#: %u\n\nchan voltage:\n", usDevID, usNumPntsToRead / bActualScanChans, uiPntCnt);
		for(usIndexChan = bActualScanChans; usIndexChan > 0; usIndexChan--)
		{
			dblCurAvgVoltage = 0.0;
			for(usIndexScan = 0; usIndexScan < (usNumPntsToRead / bActualScanChans); usIndexScan++)
			{
				uiRawCount = uiDataBuff[(usIndexChan - 1) + ((bActualScanChans) * usIndexScan)];
				dblCurAvgVoltage = dblCurAvgVoltage + (DOUBLE)(((INT)uiRawCount - 8388608) * 0.00000059604645);
			}
			dblCurAvgVoltage = dblCurAvgVoltage / ((DOUBLE)(usNumPntsToRead / bActualScanChans));
			if(usIndexChan == bActualScanChans)
			{ 
				dblCalVolts = dblCurAvgVoltage; 
				printf("7:  % 2.5lf\t(offset)\n", dblCurAvgVoltage); 
			}
			else
			{
				while (TRUE)
				{
					if((usDevID < 4990) && ((usIndexChan - 1) == 2)) 
					{
						printf("6:  % 2.5lf", dblCurAvgVoltage - dblCalVolts);
						printf("\t(full scale)"); 
						printf("\n"); 
						break;
					}
					printf("%d:  % 2.5lf", usIndexChan - 1, dblCurAvgVoltage - dblCalVolts);
					if((usDevID > 4990) && ((usIndexChan - 1) == 6)) printf("\t(full scale)"); 
					printf("\n"); 
					break;
				}
			}
		}
		uiPntCnt += usNumPntsRead;

	}
	delete [] uiDataBuff;
	getch();
	system("cls"); printf(MID"exiting scan mode - please wait...");
	MyLL_USB.EndScan(usDevID);

	//Channel could be anything after this scan so 
	// set it back to what it was when initialized
	MyLL_USB.SetCurChan(usDevID, bDevChan);

	return TRUE;
}


//----------------------------------------------\
// #### Read .ini file contents >>>>>>>>>>>>>>>>>>
//----------------------------------------------/
BOOLEAN GetIniFileContent()
{
	char szDirInfo[1024];
	sprintf(szDirInfo, "");
	GetCurrentDirectory(sizeof(szDirInfo), szDirInfo);
	strcat(szDirInfo, "\\My_USB.ini");

	bNumDevices = (BYTE)GetPrivateProfileInt("NumDevices", "Cnt", 0, szDirInfo);
	if(!bNumDevices)
	{ return FALSE; }

	if(bNumDevices > 1)
	{
		// Do something here for multiple devices. 
		// For now, just set this to a single device.
		bNumDevices = 1;
	}
	else
	{
		usDevID = (USHORT)GetPrivateProfileInt("Dev0", "DevID", 0, szDirInfo);
		bDevChan = (BYTE)GetPrivateProfileInt("Dev0", "Chan", 1, szDirInfo);

		char szRate[128];
		GetPrivateProfileString("Dev0", "Rate", "100", szRate, 8, szDirInfo);
		dblDevRate = atof(szRate);
		bDevScanType = (BYTE)GetPrivateProfileInt("Dev0", "ScanType", 1, szDirInfo);
		// bDevScanType could be anything, but for this sample program just use
		//  CMND_SINGLE_CHAN_SCAN and use inline code for setting of this variable 
		bDevScanType = CMND_SINGLE_CHAN_SCAN;
	}
	return TRUE;
}

